/*------------------------------------*\
    #OBJECTS.BUTTON-SELECT
\*------------------------------------*/
/**
 * Button select object.
 *
 * It uses a smart combination of radio buttons/checkboxes and labels
 * to provide a button-like selection experience.
 */
@import '../1-utils/utils.loader';
@import '../0-settings/settings.objects';

.#{$inuit-namespace}button-select,
%#{$inuit-namespace}button-select {
    @extend %h-clearfix;
}

// Container for one button
.#{$inuit-namespace}button-select__item,
%#{$inuit-namespace}button-select__item {
    float: left;
    margin-bottom: 6%;
    margin-right: 6%;
    position: relative;
    width: 47%;

    &::before {
        content: '';
        display: block;
        padding-bottom: 100%;
    }

    @media #{$small-only} {
        &:nth-of-type(2n) {
            margin-right: 0;
        }
    }

    @media #{$medium-up} {
        margin-right: 4%;
        margin-bottom: 4%;
        width: 22%;

        &:last-of-type {
            margin-right: 0;
        }
    }
}

// The input's label is transformed into a button.
// When clicked, the input will be checked/selected.
.#{$inuit-namespace}button-select__button,
%#{$inuit-namespace}button-select__button {
    background: $drk-color-white;
    color: $drk-color-blue;
    cursor: pointer;
    display: inline-block;
    height: 100%;
    left: 0;
    line-height: 1.3;
    padding: 0 drk-quarter($drk-base-unit-small);
    position: absolute;
    text-align: center;
    top: 0;
    vertical-align: middle;
    width: 100%;

    &::before {
        content: '';
        display: inline-block;
        height: 100%;
        vertical-align: middle;
    }

    &:hover {
        border: 1px solid $drk-color-blue;
    }

    &--img {
        border: 1px solid $drk-color-white;

        > img {
            max-width: 60px;
        }

        &:hover {
            background: $drk-color-white;
            border: 1px solid $drk-color-blue;
        }
    }

    // Use red-colored borders when there are errors.
    .has-error & {
        color: $drk-color-light-red;

        &:hover {
            color: $drk-color-white;
        }
    }

    @media #{$large-up} {
        padding: 0 drk-quarter($drk-base-unit);
    }
}

// The option holding the value that may be chosen via
// attached label/button.
.#{$inuit-namespace}button-select__option,
%#{$inuit-namespace}button-select__option {
    // Using visibility:hidden here as display:none would not work
    // width Foundation's Abide form validation.
    position: absolute;
    top: 1em;
    left: 1em;

    // When the option is selected, change the color of the attached
    // button. The element having the .button-select__option class
    // has to be declared BEFORE the .button-select__button element
    // in your markup for the sibling selector to work.
    &:checked ~ .#{$inuit-namespace}button-select__button,
    &:checked ~ %#{$inuit-namespace}button-select__button {
        border: 1px solid $drk-color-blue;

        &--img {
            background: $drk-color-white;
            border: 1px solid $drk-color-blue;
        }
    }

    // Define behavior of .button-select__option--custom. This variant
    // will let the user input it's own value once he clicked the button.
    // So when the label (button) is clicked, the option will be
    // selected and a sibling input field be shown where he can enter
    // the desired value. The option's value will be updated via
    // Javascript (uses js-field-editable class).

    // (1) Position and format currency label and hide it.
    &--custom ~ .#{$inuit-namespace}button-select__button,
    &--custom ~ %#{$inuit-namespace}button-select__button {

        .#{$inuit-namespace}button-select__currency,
        %#{$inuit-namespace}button-select__currency {
            display: none;
            padding-top: $h1-font-size;

            @media #{$medium-up} {
                padding-top: $h1-font-size-medium-up;
            }

            @media #{$large-up} {
                padding-top: $h1-font-size-large-up;
            }
        }
    }

    &--custom:checked ~ .#{$inuit-namespace}button-select__button,
    &--custom:checked ~ %#{$inuit-namespace}button-select__button {

        // (2) Display currency label
        .#{$inuit-namespace}button-select__currency,
        %#{$inuit-namespace}button-select__currency {
            display: block;
        }

        // (3) Hide the button label ('Eigener Betrag')
        .#{$inuit-namespace}button-select__label,
        %#{$inuit-namespace}button-select__label {
            display: none;
        }
    }

    // (4) Instead show input field
    &--custom:checked ~ .#{$inuit-namespace}button-select__input,
    &--custom:checked ~ %#{$inuit-namespace}button-select__input {
        background: transparent;
        border: 0;
        color: $drk-color-blue;
        display: table-cell;
        height: 100%;
        left: 0;
        padding: 0 drk-quarter($drk-base-unit-small) rem-calc($drk-base-font-size);
        position: absolute;
        text-align: center;
        top: 0;
        vertical-align: middle;
        width: 100%;

        @media #{$large-up} {
            padding: 0 drk-quarter($drk-base-unit) rem-calc($drk-base-font-size);
        }
    }

    &:checked ~ .#{$inuit-namespace}button-select__button--img,
    &:checked ~ %#{$inuit-namespace}button-select__button--img {
    }
}

.#{$inuit-namespace}button-select__btn-content,
%#{$inuit-namespace}button-select__btn-content {
    display: inline-block;
    vertical-align: middle;
}

.#{$inuit-namespace}button-select__label,
%#{$inuit-namespace}button-select__label {
    display: inline-block;
    height: 100%;
    left: 0;
    position: absolute;
    top: 0;
    vertical-align: middle;
    width: 100%;

    &::before {
        content: '';
        display: inline-block;
        height: 100%;
        vertical-align: middle;
    }
}

.#{$inuit-namespace}button-select__label-text,
%#{$inuit-namespace}button-select__label-text {
    display: inline-block;
    vertical-align: middle;
}

.#{$inuit-namespace}button-select__input,
%#{$inuit-namespace}button-select__input {
    display: none;
    font-size: $h1-font-size;
    outline: none;

    @include drk-hover {
        font-size: $h1-font-size;
    }

    @media #{$medium-up} {
        font-size: $h1-font-size-medium-up;

        @include drk-hover {
            font-size: $h1-font-size-medium-up;
        }
    }

    @media #{$large-up} {
        font-size: $h1-font-size-large-up;

        @include drk-hover {
            font-size: $h1-font-size-large-up;
        }
    }
}

.#{$inuit-namespace}button-select__amount,
%#{$inuit-namespace}button-select__amount {
    display: block;
    font-size: $h1-font-size;
    line-height: 1;

    @media #{$medium-up} {
        font-size: $h1-font-size-medium-up;
    }

    @media #{$large-up} {
        font-size: $h1-font-size-large-up;
    }
}

.#{$inuit-namespace}button-select__currency,
%#{$inuit-namespace}button-select__currency {
    display: block;
    font-family: $drk-font-family;
    line-height: 1;
    text-transform: uppercase;
}
